//                  ReactivePlusPlus library
//
//          Copyright Aleksey Loginov 2023 - present.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          https://www.boost.org/LICENSE_1_0.txt)
//
// Project home: https://github.com/victimsnino/ReactivePlusPlus
//

#pragma once

/**
 * @defgroup creational_operators Creational Operators
 * @brief Creational operators are operators that create new observable
 * @see https://reactivex.io/documentation/operators.html#creating
 * @ingroup operators
 */

#include <rpp/sources/fwd.hpp>

#include <rpp/sources/concat.hpp>
#include <rpp/sources/create.hpp>
#include <rpp/sources/defer.hpp>
#include <rpp/sources/empty.hpp>
#include <rpp/sources/error.hpp>
#include <rpp/sources/from.hpp>
#include <rpp/sources/interval.hpp>
#include <rpp/sources/never.hpp>