//                  ReactivePlusPlus library
//
//          Copyright Aleksey Loginov 2022 - present.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          https://www.boost.org/LICENSE_1_0.txt)
//
// Project home: https://github.com/victimsnino/ReactivePlusPlus
//

#pragma once

/**
 * @defgroup rppqt RPPQT
 * @brief RppQt is extension of RPP which enables support of Qt library.
 */

/**
 * @defgroup qt_operators QT Operators
 * @brief QT Operators is way to modify observables and extend with some extra custom logic but applied for QObjects
 * @ingroup rppqt
 */

#include <rppqt/sources/fwd.hpp>

/**
 * @defgroup schedulers Schedulers
 * @brief Scheduler is the way to introduce multi-threading in your application via RPP
 * @see https://reactivex.io/documentation/scheduler.html
 * @ingroup rpp
 */
#include <rppqt/schedulers/fwd.hpp>
